<div class="full-width full-height flex-column p-l-10 p-b-10">
  @if (isFeatureDisabled && canEdit()) {
    <p>
      <i
        class="sqtm-core-icon info-icon m-t-4 m-r-4"
        nz-icon
        nzType="info-circle"
        nzTheme="twotone"
        nzTwotoneColor="#1890FF"
      >
      </i>
      {{
        'sqtm-core.administration-workspace.profiles.message.profile-permission-limitation-explain'
          | translate
      }}
    </p>
  }
  <div class="full-width flex-fixed-size flex-row button-bar">
    <i
      class="flex-fixed-size current-workspace-button action-icon-size m-l-5 m-t-5"
      nz-icon
      [nzType]="'sqtm-core-generic:zoom-in'"
      nz-tooltip
      [nzTooltipTitle]="'sqtm-core.generic.label.expand-all' | translate"
      nzTooltipPlacement="top"
      [attr.data-test-element-id]="'open-all-entity-types'"
      (click)="openAllPanels()"
    ></i>
    <i
      class="flex-fixed-size current-workspace-button action-icon-size m-l-5 m-t-5"
      nz-icon
      [nzType]="'sqtm-core-generic:zoom-out'"
      nz-tooltip
      [nzTooltipTitle]="'sqtm-core.generic.label.collapse-all' | translate"
      nzTooltipPlacement="top"
      [attr.data-test-element-id]="'close-all-entity-types'"
      (click)="closeAllPanels()"
    ></i>
    <sqtm-core-text-research-field
      class="m-l-15 m-r-15 search-permission"
      (newResearchValue)="search($event)"
    ></sqtm-core-text-research-field>
  </div>
</div>
<nz-collapse
  nzGhost
  [id]="'permissionsPanel'"
  [class]="permissionsPanelClasses"
  (click)="enableEditMode($event)"
>
  @for (panel of permissionWorkspacePanels; track panel) {
    @if (panel.items) {
      <nz-collapse-panel
        [id]="panel.code"
        [class]="getPanelTitleClasses(panel.code)"
        [nzHeader]="getPanelName(panel.code)"
        [nzActive]="panel.active"
      >
        @for (permission of panel.items; track permission) {
          <ng-container
            *ngTemplateOutlet="
              rootPermissionTemplate;
              context: { $implicit: permission, panelCode: panel.code }
            "
          ></ng-container>
          @for (subPermission of permission.items; track subPermission) {
            <ng-container
              *ngTemplateOutlet="
                subPermissionTemplate;
                context: {
                  $implicit: subPermission,
                  permissionCode: permission.code,
                  panelCode: panel.code
                }
              "
            ></ng-container>
          }
        }
      </nz-collapse-panel>
    }
  }
</nz-collapse>

<span #emptyTableMessage class="hide-permission">{{
  'sqtm-core.grid.empty-grid.label' | translate
}}</span>

@if (!componentData.profile.system && editMode) {
  <div class="flex-fixed-size p-10 flex-row">
    <button
      [id]="'confirmButton'"
      [attr.data-test-element-id]="'confirm'"
      nz-button
      nzType="primary"
      (click)="handleConfirm($event)"
    >
      {{ 'sqtm-core.generic.label.confirm' | translate }}
    </button>
    <button
      [attr.data-test-element-id]="'cancel'"
      class="m-l-10"
      nz-button
      nzType="default"
      (click)="handleClose($event)"
    >
      {{ 'sqtm-core.generic.label.cancel' | translate }}
    </button>
  </div>
}

<ng-template #rootPermissionTemplate let-permission let-panelCode="panelCode">
  <div class="flex-row">
    @if (componentData.profile.system || !editMode) {
      @if (permission.active) {
        <span class="m-l-10 checked-icon">&#x2714;</span>
      } @else {
        <span class="permission-not-checked"></span>
      }
      <span
        class="permission-label"
        [attr.data-permission]="permission.code"
        [attr.data-workspace]="panelCode"
        >{{ getPermissionLabel(panelCode, permission.id) }}</span
      >
    } @else {
      <span
        nz-checkbox
        [nzDisabled]="forbidChangePermissions(panelCode)"
        [(ngModel)]="permission.active"
        (ngModelChange)="
          handlePermissionCheckboxChange($event, permission, panelCode)
        "
        [attr.data-permission]="permission.code"
        [attr.data-workspace]="panelCode"
        class="permission-checkbox-indent permission-label"
        >{{ getPermissionLabel(panelCode, permission.id) }}</span
      >
    }
    @if (permission.explainMessage) {
      <i
        nz-icon
        nzType="sqtm-core-generic:help"
        nzTheme="outline"
        nz-tooltip
        [nzTooltipTitle]="permission.explainMessage"
        class="current-workspace-button tooltip-icon table-icon-size m-l-5 m-t-2"
      >
      </i>
    }
  </div>
</ng-template>

<ng-template
  #subPermissionTemplate
  let-subPermission
  let-permissionCode="permissionCode"
  let-panelCode="panelCode"
>
  <div class="flex-row">
    @if (componentData.profile.system || !editMode) {
      @if (subPermission.active) {
        <span class="m-l-35 checked-icon">&#x2714;</span>
      } @else {
        <span class="sub-permission-not-checked"></span>
      }
      <span
        class="sub-permission-label"
        [attr.data-parent-permission]="permissionCode"
        [attr.data-permission]="subPermission.code"
        [attr.data-workspace]="panelCode"
        >{{ getPermissionLabel(panelCode, subPermission.id) }}</span
      >
    } @else {
      <span
        nz-checkbox
        [nzDisabled]="forbidChangePermissions(panelCode)"
        [(ngModel)]="subPermission.active"
        (ngModelChange)="
          handleSubPermissionCheckboxChange($event, permissionCode)
        "
        class="sub-permission-checkbox-indent sub-permission-label"
        [attr.data-parent-permission]="permissionCode"
        [attr.data-permission]="subPermission.code"
        [attr.data-workspace]="panelCode"
        >{{ getPermissionLabel(panelCode, subPermission.id) }}</span
      >
    }
    @if (subPermission.explainMessage) {
      <i
        nz-icon
        nzType="sqtm-core-generic:help"
        nzTheme="outline"
        nz-tooltip
        [nzTooltipTitle]="subPermission.explainMessage"
        class="current-workspace-button tooltip-icon table-icon-size m-l-5 m-t-2"
      >
      </i>
    }
  </div>
</ng-template>
